From 30621f28fd3a21a4162de17a12d943e811566b5e Mon Sep 17 00:00:00 2001
From: Dan Dennedy <dan@dennedy.org>
Date: Wed, 5 Dec 2018 11:14:54 -0800
Subject: [PATCH] Fix frei0r producer not working with tractor.

Reported in https://forum.shotcut.org/t/color-bars-working-not-
correctly/8308
---
 src/modules/frei0r/producer_frei0r.c | 8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

diff --git a/src/modules/frei0r/producer_frei0r.c b/src/modules/frei0r/producer_frei0r.c
index 9a90f6b6b..d1547f6c5 100644
--- a/src/modules/frei0r/producer_frei0r.c
+++ b/src/modules/frei0r/producer_frei0r.c
@@ -26,12 +26,7 @@
 
 static int producer_get_image( mlt_frame frame, uint8_t **buffer, mlt_image_format *format, int *width, int *height, int writable )
 {
-	
-	// Obtain properties of frame
-	mlt_properties properties = MLT_FRAME_PROPERTIES( frame );
-
-	// Obtain the producer for this frame
-	mlt_producer producer = mlt_properties_get_data( properties, "producer_frei0r", NULL );
+    mlt_producer producer = mlt_frame_pop_service( frame );
 
 	// Choose suitable out values if nothing specific requested
 	if ( *width <= 0 )
@@ -83,6 +78,7 @@ int producer_get_frame( mlt_producer producer, mlt_frame_ptr frame, int index )
 		mlt_properties_set_double( properties, "aspect_ratio", mlt_profile_sar( profile ) );
 
 		// Push the get_image method
+        mlt_frame_push_service( *frame, producer );
 		mlt_frame_push_get_image( *frame, producer_get_image );
 	}
 